## biosig 2.3.3

=== biosig4c++/CMakeLists.txt ===
cmake_minimum_required (VERSION 2.6)
project (libbiosig)

option (USE_ZLIB "Add support for compressed files." OFF)
option (USE_SUITESPARSE "Add support for automatic re-referencing." OFF)

# Version number
set (libbiosig_VERSION_MAJOR 1)
set (libbiosig_VERSION_MINOR 8)
set (libbiosig_VERSION_PATCH 4)

find_program (GAWK NAMES gawk)

add_custom_target (eventcodes
  COMMAND ${GAWK} -f eventcodes.awk extern/eventcodes.txt
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS eventcodes.awk extern/eventcodes.txt
)

add_custom_target (units
  COMMAND ${GAWK} -f units.awk extern/units.csv > "units.i"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS units.awk extern/units.csv
)

add_custom_target (annexb
  COMMAND ${GAWK} -f annotatedECG.awk extern/11073-10102-AnnexB.txt > "11073-10102-AnnexB.i"
  WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
  DEPENDS annotatedECG.awk extern/11073-10102-AnnexB.txt
)

set (headers
  t210/abfheadr.h
  XMLParser/tinyxml.h
  XMLParser/tinystr.h
  biosig.h
  gdftime.h
  physicalunits.h
)

set (sources
  t210/sopen_abf_read.c
  t210/sopen_alpha_read.c
  t210/sopen_axg_read.c
  t210/sopen_cfs_read.c
  t210/sopen_heka_read.c
  t210/sopen_igor.c
  t210/sopen_scp_read.c
  t210/scp-decode.cpp
  t220/crc4scp.c
  t220/sopen_scp_write.c
  t230/sopen_hl7aecg.cpp
  test0/sandbox.c
  XMLParser/tinystr.cpp
  XMLParser/tinyxml.cpp
  XMLParser/tinyxmlerror.cpp
  XMLParser/tinyxmlparser.cpp
  biosig.c
  gdftime.c
  mdc_ecg_codes.c
  physicalunits.c
)

if (WIN32)
  list (APPEND sources
    win32/getdelim.c
    win32/getline.c
    win32/getlogin.c
  )
endif ()

if (APPLE)
  list (APPEND sources
    win32/getdelim.c
    win32/getline.c
  )
endif ()

# Cannot have same name for static and shared library, 
# so we'll correct that later on
add_library (biosigstatic STATIC
  ${headers}
  ${sources}
)
set_target_properties(biosigstatic PROPERTIES OUTPUT_NAME biosig)

add_library (biosig2static STATIC
  ${headers}
  biosig2.h
  biosig-dev.h
  ${sources}
  biosig2.c
)
set_target_properties(biosig2static PROPERTIES OUTPUT_NAME biosig2)

add_library (biosigshared SHARED
  ${headers}
  ${sources}
)
set_target_properties(biosigshared PROPERTIES OUTPUT_NAME biosig)
if (APPLE)
  set_target_properties(biosigshared PROPERTIES
     INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
     )
endif ()

add_library (biosig2shared SHARED
  ${headers}
  biosig2.h
  biosig-dev.h
  ${sources}
  biosig2.c
)
set_target_properties(biosig2shared PROPERTIES OUTPUT_NAME biosig2)
if (APPLE)
  set_target_properties(biosigshared PROPERTIES
     INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/lib"
     )
endif ()

add_dependencies (biosigstatic eventcodes units annexb)
add_dependencies (biosigshared eventcodes units annexb)
add_dependencies (biosig2static eventcodes units annexb)
add_dependencies (biosig2shared eventcodes units annexb)

FIND_LIBRARY( ICONV_LIBRARY NAMES iconv )
MARK_AS_ADVANCED( ICONV_LIBRARY )
target_link_libraries( biosigstatic ${ICONV_LIBRARY} )
target_link_libraries( biosigshared ${ICONV_LIBRARY} )
target_link_libraries( biosig2static ${ICONV_LIBRARY} )
target_link_libraries( biosig2shared ${ICONV_LIBRARY} )

if (USE_ZLIB)
  add_definitions (-D=WITH_ZLIB)
  find_package( ZLIB REQUIRED )
    if ( ZLIB_FOUND )
      include_directories( ${ZLIB_INCLUDE_DIRS} )
      target_link_libraries( biosigstatic ${ZLIB_LIBRARIES} )
      target_link_libraries( biosigshared ${ZLIB_LIBRARIES} )
      target_link_libraries( biosig2static ${ZLIB_LIBRARIES} )
      target_link_libraries( biosig2shared ${ZLIB_LIBRARIES} )
    endif( ZLIB_FOUND )
endif ()

if (USE_SUITESPARSE)
  add_definitions (-D=WITH_CHOLMOD)
  FIND_LIBRARY( CHOLMOD_LIBRARY NAMES cholmod )
  MARK_AS_ADVANCED( CHOLMOD_LIBRARY )
  target_link_libraries( biosigstatic ${CHOLMOD_LIBRARY} )
  target_link_libraries( biosigshared ${CHOLMOD_LIBRARY} )
  target_link_libraries( biosig2static ${CHOLMOD_LIBRARY} )
  target_link_libraries( biosig2shared ${CHOLMOD_LIBRARY} )
endif ()

add_definitions (-D=WITHOUT_NETWORK)

install (TARGETS biosigstatic DESTINATION lib)
install (TARGETS biosigshared DESTINATION lib)
install (TARGETS biosig2static DESTINATION lib)
install (TARGETS biosig2shared DESTINATION lib)
install (FILES  biosig.h DESTINATION include)
install (FILES  biosig2.h DESTINATION include)
install (FILES  biosig-dev.h DESTINATION include)
install (FILES  gdftime.h DESTINATION include)

=== biosig4c++/DESCRIPTION ===
Name: BioSig
Version: 2.3.3
Date: 2021-08-13
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 2.9.0),
License: GPL version 3 or later
Url: http://biosig.sf.net

=== biosig4c++/Makefile ===
######## Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2020 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at https://biosig.sourceforge.io/
###
##############################################################

##### Target: GNU/Linux
#
## make && make install    build and install libbiosig, but no other tools.
#             libbiosig is a prerequisite for building all the other tools below.
#
## make save2gdf   - makes converter
## make biosig_fhir   - makes converter for fhir-binary template
## make install_save2gdf   - installs converter
## make install_mma 	installs biosig's sload for Mathematica in $PREFIX/share/biosig/mathematica
## make install_mex 	installs mexbiosig for Matlab in $PREFIX/share/biosig/mex
#
## make mex4o      - makes mexSLOAD, mexSOPEN for Octave (requires Octave-headers)
## make mex4m      - makes mexSLOAD, mexSOPEN for Matlab (requires Matlab, mex -setup must be configured)
## make mexw32     - makes mexSLOAD.mexw32, mexSOPEN.mexw32 (requires that mingw32, gnumex libraries from Matlab/Win32)
## make mexw64     - makes mexSLOAD.mexw64, mexSOPEN.mexw64 (requires that mce-w32, gnumex libraries from Matlab/Win64)
## make mex        - mex4o, mex4m, mexw32, mexw64 combined
## make biosig4java - makes Java interface (experimental)
## make biosig4php - makes PHP interface (experimental)
## make biosig4perl - makes perl interface (experimental)
## make biosig4ruby - makes ruby interface (experimental)
## make biosig4tcl - makes tcl/tk interface (experimental)
##
## make win32 and make win64 are obsolete. save2gdf.exe, and libbiosig.{a,dll} for windows can now be built
## with the mingw-cross-compiler environment (mxe.cc).
##    git clone https://github.com/schloegl/mxe.git
##    make biosig
## should do what you want. Please note, that win32mma does now also rely that libbiosig is built with MXE.
## Make sure that CROSS or CROSS64 is properly defined when running `make`
##
## ???
## make sigviewer  - makes sigviewer

##### Target: Win32
## make win32      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw32 mex/mexSLOAD.mexw32   - requires MinGW32 and GNUMEX libraries from Matlab/Win32
## make win32/sigviewer.exe 	- requires sources of SigViewer, and MinGW32 (mex: make suitesparse zlib qt )

##### Target: Win64
## make win64      - makes save2gdf.exe,libbiosig.lib,libbiosig.dll, for MSWindows, requires MinGW
## make mexw64 mex/mexSLOAD.mexw64   - requires MCE-W64 and GNUMEX libraries from Matlab/Win64
## make win64/sigviewer.exe 	- requires sources of SigViewer and MCE-W64, make suitesparse zlib qt

##### Target: MacOSX w/ homebrew
## make install_homebrew	installs libbiosig and save2gdf
	# requires: brew tap homebrew/dupes
	#	    brew install libiconv

###############################
# whether dynamic or static linking is used, can be controlled with
# LIBEXT. Setting it to 'a' links statically, 'so' links dynamically
#
LIBEXT        = a
#LIBEXT	      = so
###############################

### User-specified options: its likely you want to change this
# settings for cross compiler: tested with MXE and mce-w64 with make suitesparse zlib qt ;
CROSS   = $(HOME)/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
## local MXE
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS   = $(HOME)/src/mxe.master/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = $(shell pwd)/../mxe/usr/bin/i686-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS)-gcc)" ""
CROSS         = /usr/local/src/mxe/usr/bin/i686-w64-mingw32.static
endif

CROSS64       = $(HOME)/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif
ifeq "$(wildcard $(CROSS64)-gcc)" ""
CROSS64       = $(HOME)/src/mxe.master/usr/bin/x86_64-w64-mingw32.static
endif

# settings for mex files
MEX_OPTION    = -largeArrayDims # turn on for 64 bit Matlab, otherwise empty
# directory for sources of sigviewer
PathToSigViewer = ../sigviewer
PathToSigViewerWIN32 = ../sigviewer4win32
PathToSigViewerWIN64 = ../sigviewer4win64

CFLAGS       += -pipe -fPIC -fno-builtin-memcmp -O2 -Wno-unused-result
CFLAGS       += -Wno-deprecated
CFLAGS       += -fvisibility=hidden

prefix        = /usr/local
exec_prefix  ?= /usr/local
libdir        = ${exec_prefix}/lib
includedir    = ${prefix}/include
bindir        = ${exec_prefix}/bin
mandir        = ${prefix}/share/man

CFLAGS       += -I$(includedir)
CXXFLAGS     += $(CFLAGS)

## TARGET dependencies
ifeq (,$(TARGET))
	CC      ?= gcc
	CXX     ?= g++
	AR      := ar rcs
	PKGCONF := pkg-config
	SHAREDLIB = -shared
	DLEXT    = so
else ifeq (intel,$(TARGET))
	CC      := icc
	CXX     := icc
	LD      := xild
	AR      := xiar crs
else
	PREFIX  := $(subst /bin/,/,$(dir $(shell which $(TARGET)-gcc)))
	CC      := $(TARGET)-gcc
	CXX     := $(TARGET)-g++
	LD      := $(TARGET)-ld
	AR      := $(TARGET)-ar rcs
	PKGCONF := $(TARGET)-pkg-config
	ifneq (,$(findstring mingw,$(TARGET)))
		## add gnulib's getlogin
		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
		OBJECTS += getlogin.o getline.o getdelim.o
		LDLIBS  += -lssp
		LDLIBS  += -liconv -lstdc++ -lws2_32
		PKG_CONFIG_LIBS += -liconv -lws2_32
		BINEXT   = .exe
		DLEXT    = dll
	endif
endif

SONAMEVERSION ?= 3

### TODO: DLEXT does not work correctly on MXE/MINGW
DLDIR = $(libdir)
ifneq (,$(findstring Darwin, $(shell uname)))
	## Homebrew:
	##	brew install gawk
	##	brew install gnu-tar
	##	brew install homebrew/dupes/libiconv
	##	brew install homebrew/science/suite-sparse
	##
	LD	       = $(CXX) -shared
	CFLAGS        += -I$(prefix)/include
	CFLAGS        += -mmacosx-version-min=10.13
	LDLIBS        += -liconv -lstdc++
	SHAREDLIB      = -dylib -arch x86_64 #-macosx_version_min 10.13
	LDFLAGS       += -L$(prefix)/lib/
	DLEXT          = dylib
	FULLDLEXT      = .dylib
	SONAME_PREFIX  = -install_name # the last space character is crucial

else ifneq (,$(findstring CYGWIN, $(shell uname)))
	### TODO: check if this path is useful at all ###
	DLEXT = dll
	LD	       = $(CXX)
	LDLIBS        += -liconv -lstdc++
	FULLDLEXT      = ${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=

else ifneq (,$(findstring MINGW, $(shell uname)))
	### TODO: check if this path is useful at all ###
	## add gnulib's getlogin
	SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
	OBJECTS += getlogin.o getline.o getdelim.o
	## exclude conflicting definition of sopen from mingw's io.h
	CC  = gcc
	CXX = g++
	CFLAGS  += -pipe -fPIC -D_REENTRANT -D=BUILD_DLL
	LD	 = $(CXX)
	FULLDLEXT      = ${SONAMEVERSION}.dll
	SONAME_PREFIX  = -Wl,-soname=
	LDLIBS  += -lstdc++
	LDLIBS  += -liconv -lws2_32
	LDFLAGS += -Wl,-subsystem,windows
	LDFLAGS += -L$(prefix)/lib/
	DLDIR = $(bindir)

else
	LD	       = $(CXX)
	ifneq (,$(findstring mingw,$(TARGET)))
		FULLDLEXT      = ${SONAMEVERSION}.dll
		DLDIR = $(bindir)
	else
		FULLDLEXT      = .so.${SONAMEVERSION}
	endif
	SONAME_PREFIX  = -Wl,-soname=
endif

DEFINES_ALL   = #-D=NDEBUG

DEFINES      += $(DEFINES_ALL)
#DEFINES      += -D=WITH_SON
#DEFINES      += -D=WITHOUT_SCP_DECODE
#DEFINES      += -D=WITH_TIMESTAMPEVENT
#DEFINES      += -D=WITH_TIMESTAMPCHANNEL
### Mingw,MXE, etc. must avoid name space conflict concerning SOPEN ###
#DEFINES      += -D=NO_OLDNAMES

#DEFINES      += -D=WITH_CURL
DEFINES      += -D=__4HAERTEL__
DEFINES      += -D=WITH_FAMOS
DEFINES      += -D=WITH_FIFF
DEFINES      += -D=WITHOUT_NETWORK
DEFINES      += -D=WITH_SCP3
DEFINES      += -D=WITH_FEF
#DEFINES      += -D=WITH_PDP
	### DICOM: DCMTK or GDCM, or internal
	# WITH_DCMTK is already configured by autoconf
	# WITH_GDCM is experimental
	# WITH_DICOM (internal implementation) is experimental
#DEFINES      += -D=WITH_GDCM
#DEFINES      += -D=WITH_GSL
#DEFINES      += -D=WITH_EEPROBE
DEFINES      += -D=WITH_INTAN
#DEFINES      += -D=WITH_TDMS
DEFINES      += -D=WITH_ATF
#DEFINES      += -D=WITH_AVI
#DEFINES      += -D=WITH_RIFF
#DEFINES      += -D=WITH_WAV
#DEFINES      += -D=WITH_NEV
DEFINES      += -D=MAKE_EDFLIB

ifeq (1,1)
	LDLIBS     += -lz
endif
ifeq (1,@HAVE_LIBPTHREAD@)
	LDLIBS     += -lpthread
endif
ifeq (1,1)
	LDLIBS     += -lcholmod
	ifeq (Darwin,$(shell uname))
	  ## homebrew requires this in addition to cholmod
	  LDLIBS     += -lsuitesparseconfig
	endif
endif
ifeq (1,1)
	DEFINES      += -D=WITH_DCMTK
	LDLIBS       += -ldcmdata -loflog -lofstd
	SOURCES      += t210/sopen_dcmtk_read.cpp
	OBJECTS      += sopen_dcmtk_read.o
	MinGWOBJECTS += win32/sopen_dcmtk_read.obj
endif
ifeq (1,@HAVE_LIBHDF5@)
	LDLIBS     += -lhdf5
endif
ifeq (1,@HAVE_LIBMATIO@)
	LDLIBS     += -lmatio
endif
ifeq (1,1)
	LDLIBS     += -lm
endif
ifeq (1,1)
	DEFINES    += -D=WITH_LIBTINYXML
	LDLIBS     += -ltinyxml
endif
ifeq (1,@HAVE_LIBTINYXML2@)
	DEFINES    += -D=WITH_LIBTINYXML2
	LDLIBS     += -ltinyxml2
endif

ifneq (,$(findstring WITH_GDCM, $(DEFINES)))
  INCPATH    += -I$(wildcard /usr/include/gdcm-2*/)
  LDLIBS     += -lgdcmCommon -lgdcmDSED -lgdcmMEXD -lgdcmMSFF -lgdcmDICT -lgdcmIOD
endif

ifneq (,$(findstring WITH_CURL, $(DEFINES)))
  LDLIBS     += -lcurl
endif
ifneq (,$(findstring stack-protector, $(CFLAGS)))
ifneq (,$(findstring CYGWIN, $(shell uname)))
  LDLIBS     += -lssp
endif
ifneq (,$(findstring MINGW, $(shell uname)))
  LDLIBS     += -lssp
endif
endif

DELETE        = rm -f
COPY          = cp -f
DATA_DIR      = data/
DATA_DIR_CFS  = $(HOME)/L/data/test/cfs/
TEMP_DIR      = test/
SED           = sed
TAR           = tar
VERBOSE	     := -V0

##########################################################
## set Matlab and Octave variables
ifeq (undefined,$(origin MATLABDIR))
  ifeq (Darwin,$(shell uname))
    MATLABDIR := $(shell find /Applications/MATLAB* -name bin -type d -depth 1 2>/dev/null | head -1)
  else
    MATLABDIR ?= $(shell find /usr/local/MATLAB* -maxdepth 2 -name bin -type d 2>/dev/null | head -1)
  endif
endif

ifeq (,$(MATLABDIR))
  #$(warning MATLABDIR is not defined)
else
  MEX         = $(MATLABDIR)/mex
  MEX_EXT    := $(shell $(MATLABDIR)/mexext)
endif

##########################################################

##########################################################
## set variables for MinGW Crosscompiler: compile on linux binaries for windows
##
PathToMinGW   = $(dir $(CROSS))..$(nondir $(CROSS))
PathToMinGW64 = $(dir $(CROSS64))..$(nondir $(CROSS64))

MinGWCC      = $(CROSS)-gcc
MinGWCXX     = $(CROSS)-g++
MinGWDEF     = $(DEFINES)
MinGWCFLAGS  = -pipe -fPIC  -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin32 -I$(PathToMinGW)/include/
MinGWLIBS    = win32/libbiosig.a -L$(PathToMinGW)/lib/ $(LDLIBS) # static
MinGWLINK    = $(MinGWCXX)

MinGW64CC      = $(CROSS64)-gcc
MinGW64CXX     = $(CROSS64)-g++
MinGW64CFLAGS  = -pipe -fPIC -O2 -D_REENTRANT -D=BUILD_DLL $(MinGWDEF) -Iwin64 -I$(PathToMinGW64)/include/
MinGW64LIBS    = win64/libbiosig.a -L$(PathToMinGW64)/lib/ $(LDLIBS) # static
MinGW64LINK    = $(MinGW64CXX)
##########################################################

# Versioning
MAJOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig-dev.h))
MINOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig-dev.h))
STEPPING       := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig-dev.h))
BIOSIG_VERSION := 2.3.3
TODAY          := $(shell date +%Y%m%d)

####### Output directory
OBJ	      = ./obj

####### Files
SOURCES      += biosig.c \
		biosig2.c \
		t210/sopen_cfs_read.c \
		t210/sopen_heka_read.c \
		t210/sopen_igor.c \
		t210/sopen_rhd2000_read.c \
		t210/sopen_scp_read.c \
		t210/sopen_tdms_read.c \
		t210/sopen_famos_read.c \
		t210/sopen_abf_read.c \
		t210/sopen_alpha_read.c \
		t210/sopen_axg_read.c \
		t210/sopen_cadwell_read.c \
		t210/scp-decode.cpp \
		t220/sopen_scp_write.c \
		t220/crc4scp.c \
		t230/sopen_hl7aecg.cpp \
		t240/sopen_fef_read.c \
		test0/sandbox.c \
		xgethostname.c \
		gdftime.c \

=== biosig4c++/R/DESCRIPTION ===
Package: biosig
Version: 2.3.3
Date: 2020-08-22
Encoding: UTF-8
Title: Biomedical Signal Tools
Authors@R: person("Alois", "Schlögl", role = c("aut", "cre"),
                     email = "alois.schloegl@gmail.com", comment="https://orcid.org/0000-0002-5621-8100")
Author: Alois Schlögl [aut, cre]
Maintainer: Alois Schlögl <alois.schloegl@gmail.com>
Depends: R (>= 3.1.0)
Suggests: 
Description: Import filter for about 50 different biomedical signals data formats.
License: GPL (>= 3)
URL: https://biosig.sourceforge.io, http://pub.ist.ac.at/~schloegl
BugReports: https://sourceforge.net/projects/biosig/support

=== biosig4c++/R/Makefile ===

BIOSIG4R_PKG = biosig_2.3.3.tar.gz

build: $(BIOSIG4R_PKG)

sload.so: sload.c
	R CMD SHLIB sload.c -I.. -L.. -lbiosig

clean:
	rm *.o *.so *.gz $(BIOSIG4R_PKG)

$(BIOSIG4R_PKG):
	R CMD build .
	R CMD check --as-cran $@

install: $(BIOSIG4R_PKG)
	R CMD INSTALL $<

=== biosig4c++/magic/Makefile ===
biosig.mgc: biosig
	file  -C -m biosig

test: biosig.mgc file.list
	file -m biosig.mgc -f file.list
	
file.list:
	echo "set up file.list containing list files for testing. this can done like"
	echo "	ls -1 >file.list"
	echo "  find . >file.list"
	
clean: 
	rm *.mgc

=== biosig4c++/mma/Makefile ===
####### Makefile to compile biosig.exe for loading data supported by libbiosig into Mathematica
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################


###########################################
# user-defined variables
###########################################
CROSS   ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/i686-w64-mingw32.static
CROSS64 ?= /home/schloegl/src/mxe.github.schloegl/usr/bin/x86_64-w64-mingw32.static

exec_prefix ?= /usr/local

###########################################
## set Mathematica variables
MATHEMATICA_EXE = :
MATHEMATICA_EXE ?= $(shell which mathematica)
ifeq (,$(MATHEMATICA_EXE))
        $(error "mathematica not found in $$PATH - cannot compile biosig for Mathematica")
endif
MLINKDIR ?= $(shell dirname $(shell dirname $(shell readlink -f $(MATHEMATICA_EXE) ) ) )

ifneq (,$(findstring Darwin,$(shell uname)))
MLINKDIR := /Applications/Mathematica.app/Contents/
SYS       = MacOSX-x86-64
LDFLAGS  += -demangle -dynamic -arch x86_64
LDFLAGS  += -framework CoreFoundation -framework CoreVideo -framework VideoDecodeAcceleration
else
SYS 	  = $(notdir $(shell ls -1d $(MLINKDIR)/SystemFiles/Links/MathLink/DeveloperKit/*))
ifneq (1,$(words ${SYS}))
SYS       = Linux-x86-64# Set this value with the result of evaluating $SystemID
endif
endif

# automated detection of most recent MLINTERFACE, without starting mathematica
# 10.0 supports 3 and 4, 9.0 and earlier supports only 3,
MLIVER := $(shell ${CC} mliver.c -I${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions/ -E -o - | tail -1)

#
# Windows
SYSwin       = Windows# Set this value with the result of evaluating $SystemID
MLLIBwin     = ml32i4m# Set this to ML64i3 if using a 64-bit system
SYSwin64     = Windows-x86-64# Set this value with the result of evaluating $SystemID
MLLIBwin64   = ml64i4# Set this to ML64i3 if using a 64-bit system
###########################################

CADDSDIR  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYS}/CompilerAdditions
INCDIR    = -I${CADDSDIR} -I${MLINKDIR}/SystemFiles/IncludeFiles/C/
LIBDIR   += -L${CADDSDIR}

EXTRALIBS += -lm -ldl -luuid -lstdc++ # Set these with appropriate libs for your system.

ifeq (Darwin,$(shell uname))
MLLIB   = MLi${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
SED	= gsed
else
MLLIB   = ML$(shell getconf LONG_BIT)i${MLIVER} # ML32i3 # Set this to ML64i3 if using a 64-bit system
EXTRALIBS += -lrt
SED	= sed
endif
LD 	= ${CC}


ifneq (${MLIVER},)
CFLAGS += -DMLINTERFACE=${MLIVER}
endif

MPREP     = ${CADDSDIR}/mprep

TARGET    = biosig

# make Linux-x86-64
mma : $(patsubst %, ${SYS}/%.exe, $(TARGET))
# make Linux-x86-64, Windows, Windows-x86-64
all : $(patsubst %, ${SYS}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin}/%.exe, $(TARGET)) $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

.c.o:
	${CC} ${CFLAGS} -I.. ${INCDIR} -c "$<"

%tm.c: %.tm
	${MPREP} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYS}/%.exe: %.o %tm.o
	mkdir -p ${SYS}
	${LD} ${LDFLAGS} $? ${LIBDIR} -l${MLLIB} ${EXTRALIBS} -L.. -lbiosig  -o "$@"
	ln -sf "$@"


### Install Biosig for Mathematica
install : biosig.exe
	mkdir -p $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica
	install biosig.exe	$(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/
	@echo "  Biosig for Mathematica is installed in $(exec_prefix)/libexec/biosig/mathematica/biosig.exe";
	@echo "  Usage: Start Mathematica and run";
	@echo "\tlink=Install[\"$(exec_prefix)/libexec/biosig/mathematica/biosig.exe\"];";
	@echo "\t?Sload\n\t?Uload\n";

uninstall:
	${RM} $(DESTDIR)$(datadir)/biosig/mathematica/{sload,biosig}.exe
	-cd $(DESTDIR)$(datadir) && rmdir -p biosig/mathematica
	${RM} $(DESTDIR)$(exec_prefix)/libexec/biosig/mathematica/biosig.exe
	-cd $(DESTDIR)$(exec_prefix)/libexec && rmdir -p biosig/mathematica

###########################################
#   Win32 - cross-compilation
###########################################

CCw32        = $(CROSS)-gcc
CADDSDIRwin  = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin}/CompilerAdditions
INCDIRwin    = -I${CADDSDIRwin}
LIBDIRwin    = ${CADDSDIRwin}

EXTRALIBSwin = -lgdi32 -lm -lstdc++ -lws2_32 $(LDLIBS) # Set these with appropriate libs for your system.

MPREPwin     = ${CADDSDIRwin}/mprep.exe

%tm.win32.c : %.tm
	WINEPREFIX=${HOME}/.wine32.mma wine ${MPREPwin} "$<" -o "$@"
	${SED} -i 's# __DATE__# ",__DATE__," ",__TIME__,"#g' "$@"

${SYSwin}/%.obj : %.c
	${CCw32} -o "$@" -c "$<" $(shell $(CROSS)-pkg-config --cflags libbiosig) ${INCDIRwin}

win32mma : $(patsubst %, ${SYSwin}/%.exe, $(TARGET))

#${SYSwin}/%.exe : ${SYSwin}/%.obj ${SYSwin}/%tm.obj		# uses MPREP
${SYSwin}/%.exe : ${SYSwin}/%.obj ${SYSwin}/%tm.win32.obj	# uses MPREPwin
	mkdir -p ${SYSwin}
	${CCw32} $? -mwindows -static-libgcc -static-libstdc++ $(shell $(CROSS)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin} -l${MLLIBwin} ${EXTRALIBSwin} -o "$@"


###########################################
#   Win64 - cross-compilation
###########################################

CCw64         = $(CROSS64)-gcc
CADDSDIRwin64 = ${MLINKDIR}/SystemFiles/Links/MathLink/DeveloperKit/${SYSwin64}/CompilerAdditions
INCDIRwin64   = -I${CADDSDIRwin64}
LIBDIRwin64   = ${CADDSDIRwin64}

#MPREPwin64    = ${CADDSDIRwin64}/mprep.exe

#%tm.win64.c : %.tm
#	WINEPREFIX=${HOME}/.wine64.mma wine64 ${MPREPwin64} "$<" -o "$@"
	#${MPREP} "$<" -o "$@"
#	${SED}  -i 's# __DATE__# ",__DATE__," ",__TIME__,"#' "$@"

${SYSwin64}/%.obj : %.c
	${CCw64} -o "$@" -c "$<" $(shell $(CROSS64)-pkg-config --cflags libbiosig) ${INCDIRwin64}

win64mma : $(patsubst %, ${SYSwin64}/%.exe, $(TARGET))

#${SYSwin64}/%.exe : ${SYSwin64}/%.obj ${SYSwin64}/%tm.win64.obj	# uses MPREPwin64
${SYSwin64}/%.exe : ${SYSwin64}/%.obj ${SYSwin64}/%tm.obj		# uses MPREP
	mkdir -p ${SYSwin64}
	${CCw64} $? -static-libgcc -static-libstdc++ $(shell $(CROSS64)-pkg-config --libs libbiosig) -lssp -L${LIBDIRwin64} -l${MLLIBwin64} ${EXTRALIBSwin} -o "$@"


###########################################
clean:
	-$(RM) *.o* */*.o*
	-$(RM) *tm.c */*tm.c
	-$(RM) *.exe */*.exe

=== biosig4c++/php/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  $Id: Makefile 2526 2010-08-27 21:46:28Z schloegl $
###  Copyright (C) 2010 Alois Schloegl <a.schloegl@ieee.org>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

# More information on SWIG-PHP interface is available here
# http://www.swig.org/Doc1.3/Php.html#Php

all:
	swig -c++ -php biosig.i
	gcc `php-config --includes` -fpic -c biosig_wrap.cpp
	gcc -shared biosig_wrap.o -o php_biosig.so

clean:
	-rm *.h 
	-rm *.o 
	-rm *.cpp 
	-rm *.so

=== biosig4c++/python/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2006-2021 Alois Schloegl <alois.schloegl@ist.ac.at>
###  This file is part of the "BioSig for C/C++" repository 
###  (biosig4c++) at http://biosig.sf.net/ 
###
##############################################################

PYTHON ?= python3
PYVER  := $(shell $(PYTHON) -c "import sys; print(sys.version[:3])")

release target : sdist build

wheel: bdist_wheel

dist/Biosig-2.3.3.tar.gz : sdist

sdist build install bdist_wheel ::
	$(PYTHON) setup.py $@

test:
	## get ../data/Newtest17-256.bdf
	$(MAKE) -C .. fetchdata
	## need to run from different directory, because
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.header("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) -c 'import biosig; print(biosig.data("data/Newtest17-256.bdf"))')
	(cd .. && PYTHONPATH=/usr/local/lib/python$(PYVER)/dist-packages/ $(PYTHON) < python/demo2.py)

clean:
	-rm -rf build/*
	-rm -rf dist/*
	-rm *.so

check: release
	twine check dist/*

=== debian/changelog ===
biosig (2.3.3-1build2) jammy; urgency=medium

  * No-change rebuild with Python 3.10 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 16 Mar 2022 22:33:32 +0000

biosig (2.3.3-1build1) jammy; urgency=medium

  * No-change rebuild against octave 6.4.0

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 19 Jan 2022 09:23:13 +0000

biosig (2.3.3-1) unstable; urgency=medium

  [ Alois Schlögl ]
  * libbiosig:
  - improved support for the following data formats:
    EDF+ : relax requirement that reserved field must start with "EDF+"
    ABF2 : check scaling - seems good
    ATF  : support multi-channel traces, segments will be concatanated
           (and not considered different channels)
    AXG  : extend support to some real-world data sets

  * biosig4matlab
  - add Machine-Learning-Optimal-Detection (MOD) method (Zhang et al. 2020,2021)
    including demo script
  - <NEW> rotary-decoder added (used in Zhang et al. 2020)
    biosig4matlab/t250_ArtifactPreProcessingQualityControl/rotary_decoder.m
  - sopen (gdf): add support for timezone information
  - fix issue eeglab#93 (encoding of EDF+ annotations)

  [ Andreas Tille ]
  * Standards-Version: 4.6.0 (routine-update)

 -- Alois Schlögl <alois.schloegl@gmail.com>  Sat, 02 Oct 2021 15:32:14 +0200

=== debian/control ===
Source: biosig
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Yaroslav Halchenko <debian@onerussian.com>,
           Michael Hanke <michael.hanke@gmail.com>,
           Alois Schlögl <alois.schloegl@gmail.com>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               d-shlibs,
               gawk,
               python3-setuptools,
               python3-all-dev,
               python3-numpy,
               zlib1g-dev,
               libsuitesparse-dev,
               dh-octave,
               libdcmtk-dev,
               libtinyxml-dev,
               libb64-dev
Standards-Version: 4.6.0
Vcs-Browser: https://salsa.debian.org/med-team/biosig
Vcs-Git: https://salsa.debian.org/med-team/biosig.git
Homepage: https://biosig.sourceforge.io/
Rules-Requires-Root: no
Testsuite: autopkgtest-pkg-python

Package: libbiosig3
Architecture: any
Multi-Arch: same
Section: libs
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - dynamic library
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides dynamic library.

Package: libbiosig-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: libbiosig3 (= ${binary:Version}),
         ${devlibs:Depends},
         ${misc:Depends}
Description: I/O library for biomedical data - development files
 BioSig is a library for accessing files in several biomedical data formats
 (including EDF, BDF, GDF, BrainVision, BCI2000, CFWB, HL7aECG,
 SCP_ECG (EN1064), MFER, ACQ, CNT(Neuroscan), DEMG, EGI, EEG1100,
 FAMOS, SigmaPLpro, TMS32).  The complete list of supported file
 formats is available at http://pub.ist.ac.at/~schloegl/biosig/TESTED .
 .
 This package provides header files and static library.

Package: biosig-tools
Architecture: any
Depends: libbiosig3 (= ${binary:Version}),
         ${shlibs:Depends},
         ${misc:Depends}
Description: format conversion tools for biomedical data formats
 Based on BioSig library, this package provides command line
 tools, such as
 .
  - save2gdf: converter between different file formats, including but
        not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF,
        BDF, CWFB.
  - biosig2gdf: converts biosig data files into GDF, to simplify
        parsing and loading by scripting languages (e.g. loadgdf.{py,r})
  - rec2bin, bin2rec, heka2itx, save2aecg, save2scp: several converter
       tools based on save2gdf
  - biosig_fhir: packs biosignal data into HL7/FHIR binary template file.
  - physicalunits: converter for encoding and decoding of physical
       units according to ISO 11073-10101

Package: python3-biosig
Architecture: any
Multi-Arch: same
Section: python
Depends: libbiosig3 (= ${binary:Version}),
         ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
Description: Python3 bindings for BioSig library
 This package provides Python3 bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

Package: octave-biosig
Architecture: any
Multi-Arch: same
Depends: libbiosig3 (= ${binary:Version}),
         ${octave:Depends},
         ${shlibs:Depends},
         ${misc:Depends}
Description: Octave bindings for BioSig library
 This package provides Octave bindings for BioSig library.  Primary
 goal -- I/O interface to variety of biomedical file formats, including
 but not limited to SCP-ECG(EN1064), HL7aECG (FDA-XML), GDF, EDF.

## biosig 2.4.0

=== Makefile ===
####### Main Makefile for building the various biosig tools ####################
###
###  Copyright (C) 2010-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
################################################################################

exec_prefix ?= $(prefix)

first :: lib tools

java: lib
	$(MAKE) -C biosig4c++/java

lib:
	$(MAKE) -C biosig4c++ lib

tools: lib
	$(MAKE) -C biosig4c++ tools

mma mathematica: lib
	$(MAKE) -C biosig4c++/mma

mex4m matlab: lib
	$(MAKE) -C biosig4c++/mex mex4m

R: lib
	$(MAKE) -C biosig4c++/R

install ::
	$(MAKE) -C biosig4c++ install
	install -d $(DESTDIR)/usr/local/share/biosig/matlab
	cp -r biosig4matlab/* $(DESTDIR)/usr/local/share/biosig/matlab/
	-rm -rf $(DESTDIR)/usr/local/share/biosig/matlab/maybe-missing

uninstall ::
	$(MAKE) -C biosig4c++ uninstall
	-rm -rf $(DESTDIR)/usr/local/share/biosig

clean ::
	-$(MAKE) -C biosig4c++/mma clean
	$(MAKE) -C biosig4c++ clean
	-rm mexbiosig*.src.tar.gz
	-rm biosig4octave*.src.tar.gz

distclean : clean
        # also configure.ac for list of files
	-rm config.log
	-rm config.status
	rm Makefile biosig4c++/Makefile biosig4c++/*/Makefile \
		biosig4c++/python/setup.py \
		biosig4c++/R/DESCRIPTION

ifneq (:,/usr/bin/java)
ifneq (:,:)
first :: lib
	-$(MAKE) -C biosig4c++/java
endif
clean ::
	-$(MAKE) -C biosig4c++/java clean
test ::
	-$(MAKE) -C biosig4c++/java test
endif

ifneq (:,:)
first :: lib
	$(MAKE) -C biosig4c++/mma
install ::
	-$(MAKE) -C biosig4c++/mma install
uninstall ::
	-$(MAKE) -C biosig4c++/mma uninstall
endif

ifneq (:,:)
MATLAB_MEX := $(shell dirname :)/mex
first ::
	$(MAKE) -C biosig4c++/mex mex4m
install ::
	$(MAKE) -C biosig4c++/mex install
uninstall ::
	$(MAKE) -C biosig4c++/mex uninstall
endif

# source package mexbiosig and biosig4octave
first :: biosig4octave
mexbiosig ::
	$(MAKE) -C biosig4c++ mexbiosig
	ln -sf biosig4c++/mex/mexbiosig-2.4.0.src.tar.gz
biosig4octave ::
	$(MAKE) -C biosig4c++ biosig4octave
	ln -sf biosig4c++/mex/biosig4octave-2.4.0.src.tar.gz

ifneq (:,/usr/bin/octave)
ifneq (:,/usr/bin/mkoctfile)
BIOSIG_MEX_DIR = $(DESTDIR)$(shell octave-config -p LOCALOCTFILEDIR)/biosig
BIOSIG_DIR     = $(DESTDIR)$(shell octave-config -p LOCALFCNFILEDIR)/biosig
first ::
	MKOCTFILE="/usr/bin/mkoctfile" $(MAKE) -C biosig4c++/mex mex4o
install ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg install -global biosig4c++/mex/mexbiosig-2.4.0.src.tar.gz"
	# *.mex
	install -d $(BIOSIG_MEX_DIR)
	install biosig4c++/mex/*.mex $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	install -d $(BIOSIG_DIR)
	cp -r biosig4matlab/*  $(BIOSIG_DIR)
	-rm -rf $(BIOSIG_DIR)/maybe-missing

uninstall ::
	# mexbiosig
	#-/usr/bin/octave --no-gui --eval "pkg uninstall -global mexbiosig"
	# *.mex
	-rm -rf $(BIOSIG_MEX_DIR)
	# biosig for octave and matlab
	-rm -rf $(BIOSIG_DIR)
endif
endif

ifneq (:,/usr/bin/php)
first ::
	-$(MAKE) -C biosig4c++/php
install ::
	-$(MAKE) -C biosig4c++/php install
clean ::
	-$(MAKE) -C biosig4c++/php clean
endif

ifneq (:,/usr/bin/python3)
first :: python
python ::
	-PYTHON=/usr/bin/python3 $(MAKE) -C biosig4c++/python sdist
	-$(foreach py, $(shell pyversions -i),  PYTHON=$(py) $(MAKE) -C biosig4c++/python build; )
	-$(foreach py, $(shell py3versions -i), PYTHON=$(py) $(MAKE) -C biosig4c++/python build; )
install ::
	-PYTHON=/usr/bin/python3 $(MAKE) -C biosig4c++/python install
	-$(foreach py, $(shell pyversions -i),  PYTHON=$(py) $(MAKE) -C biosig4c++/python install; )
	-$(foreach py, $(shell py3versions -i), PYTHON=$(py) $(MAKE) -C biosig4c++/python install; )
uninstall ::
	-/usr/bin/python3 -m pip uninstall -y Biosig
	-$(foreach py, $(shell pyversions -i),  $(py) -m pip uninstall -y Biosig;)
	-$(foreach py, $(shell py3versions -i), $(py) -m pip uninstall -y Biosig;)
clean ::
	$(MAKE) -C biosig4c++/python clean
endif

ifneq (:,/usr/bin/R)
first ::
	-$(MAKE) -C biosig4c++/R build
install ::
	-$(MAKE) -C biosig4c++/R install
clean ::
	-$(MAKE) -C biosig4c++/R clean
endif

all: first #win32 win64 #sigviewer #win32/sigviewer.exe win64/sigviewer.exe #biosig_client biosig_server mma java tcl perl php ruby #sigviewer

#---- automatic remaking ---------------------------------------------------#
#   https://www.gnu.org/software/autoconf/manual/autoconf-2.69/html_node/Automatic-Remaking.html#Automatic-Remaking
#---------------------------------------------------------------------------#
$(srcdir)/configure: configure.ac aclocal.m4
	autoconf

# autoheader might not change config.h.in, so touch a stamp file.
$(srcdir)/config.h.in: stamp-h.in
$(srcdir)/stamp-h.in: configure.ac aclocal.m4
	autoheader
	echo timestamp > '$(srcdir)/stamp-h.in'

config.h: stamp-h
stamp-h: config.h.in config.status
	./config.status

Makefile: Makefile.in config.status
	./config.status

config.status: configure
	./config.status --recheck

=== biosig4c++/DESCRIPTION ===
Name: BioSig
Version: 2.4.0
Date: 2022-03-19
Author: Alois Schloegl <alois.schloegl@gmail.com>
Maintainer: Alois Schloegl
Title: BioSig
Description: A software library for biomedical signal processing.
Depends: octave (> 4.0.0),
License: GPL version 3 or later
Url: http://biosig.sf.net

=== biosig4c++/Makefile ===
--- 
+++ 
@@ -124,6 +124,7 @@
 	LD      := $(TARGET)-ld
 	AR      := $(TARGET)-ar rcs
 	PKGCONF := $(TARGET)-pkg-config
+	TARGETPLATFORM = windows
 	ifneq (,$(findstring mingw,$(TARGET)))
 		## add gnulib's getlogin
 		SOURCES += win32/getlogin.c win32/getline.c win32/getdelim.c
@@ -137,6 +138,7 @@
 endif
 
 SONAMEVERSION ?= 3
+DLPRE = lib
 
 ### TODO: DLEXT does not work correctly on MXE/MINGW
 DLDIR = $(libdir)
@@ -158,12 +160,16 @@
 	SONAME_PREFIX  = -install_name # the last space character is crucial
 
 else ifneq (,$(findstring CYGWIN, $(shell uname)))
-	### TODO: check if this path is useful at all ###
 	DLEXT = dll
+	DLPRE = cyg
+	DLDIR = $(bindir)
+	LIBEXT = dll.a
+	BINEXT = .exe
 	LD	       = $(CXX)
 	LDLIBS        += -liconv -lstdc++
-	FULLDLEXT      = ${SONAMEVERSION}.dll
+	FULLDLEXT      = -${SONAMEVERSION}.dll
 	SONAME_PREFIX  = -Wl,-soname=
+	TARGETPLATFORM = windows
 
 else ifneq (,$(findstring MINGW, $(shell uname)))
 	### TODO: check if this path is useful at all ###
@@ -182,15 +188,20 @@
 	LDFLAGS += -Wl,-subsystem,windows
 	LDFLAGS += -L$(prefix)/lib/
 	DLDIR = $(bindir)
+	TARGETPLATFORM = windows
+
+else ifneq (,$(findstring mingw,$(TARGET)))
+	## mingw, MXE
+	LD	       = $(CXX)
+	FULLDLEXT      = -${SONAMEVERSION}.dll
+	DLEXT          = dll
+	DLDIR = $(bindir)
+	TARGETPLATFORM = windows
+	SONAME_PREFIX  = -Wl,-soname=
 
 else
 	LD	       = $(CXX)
-	ifneq (,$(findstring mingw,$(TARGET)))
-		FULLDLEXT      = ${SONAMEVERSION}.dll
-		DLDIR = $(bindir)
-	else
-		FULLDLEXT      = .so.${SONAMEVERSION}
-	endif
+	FULLDLEXT      = .so.${SONAMEVERSION}
 	SONAME_PREFIX  = -Wl,-soname=
 endif
 
@@ -219,9 +230,7 @@
 #DEFINES      += -D=WITH_GDCM
 #DEFINES      += -D=WITH_GSL
 #DEFINES      += -D=WITH_EEPROBE
-DEFINES      += -D=WITH_INTAN
 #DEFINES      += -D=WITH_TDMS
-DEFINES      += -D=WITH_ATF
 #DEFINES      += -D=WITH_AVI
 #DEFINES      += -D=WITH_RIFF
 #DEFINES      += -D=WITH_WAV
@@ -249,13 +258,19 @@
 	MinGWOBJECTS += win32/sopen_dcmtk_read.obj
 endif
 ifeq (1,@HAVE_LIBHDF5@)
-	LDLIBS     += -lhdf5
+	DEFINES    += -DWITH_HDF5=1
+	LDLIBS     += -lhdf5 -lhdf5_hl
 endif
 ifeq (1,@HAVE_LIBMATIO@)
+	DEFINES    += -DWITH_MATIO=1
 	LDLIBS     += -lmatio
 endif
 ifeq (1,1)
 	LDLIBS     += -lm
+endif
+ifeq (1,@HAVE_SQLITE3@)
+	DEFINES    += -DWITH_SQLITE3=1 -DSQLITE_THREADSAFE=0 -DSQLITE_OMIT_LOAD_EXTENSION
+	LDLIBS     += -lsqlite3
 endif
 ifeq (1,1)
 	DEFINES    += -D=WITH_LIBTINYXML
@@ -335,7 +350,7 @@
 MAJOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MAJOR' biosig-dev.h))
 MINOR_VERSION  := $(word 3, $(shell grep '\#define BIOSIG_VERSION_MINOR' biosig-dev.h))
 STEPPING       := $(word 3, $(shell grep '\#define BIOSIG_PATCHLEVEL' biosig-dev.h))
-BIOSIG_VERSION := 2.3.3
+BIOSIG_VERSION := 2.4.0
 TODAY          := $(shell date +%Y%m%d)
 
 ####### Output directory
@@ -345,21 +360,6 @@
 SOURCES      += biosig.c \
 		biosig2.c \
 		t210/sopen_cfs_read.c \
+		t210/sopen_hdf5.c \
 		t210/sopen_heka_read.c \
 		t210/sopen_igor.c \
-		t210/sopen_rhd2000_read.c \
-		t210/sopen_scp_read.c \
-		t210/sopen_tdms_read.c \
-		t210/sopen_famos_read.c \
-		t210/sopen_abf_read.c \
-		t210/sopen_alpha_read.c \
-		t210/sopen_axg_read.c \
-		t210/sopen_cadwell_read.c \
-		t210/scp-decode.cpp \
-		t220/sopen_scp_write.c \
-		t220/crc4scp.c \
-		t230/sopen_hl7aecg.cpp \
-		t240/sopen_fef_read.c \
-		test0/sandbox.c \
-		xgethostname.c \
-		gdftime.c \

=== biosig4c++/R/DESCRIPTION ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Package: biosig
-Version: 2.3.3
+Version: 2.4.0
 Date: 2020-08-22
 Encoding: UTF-8
 Title: Biomedical Signal Tools

=== biosig4c++/R/Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 
-BIOSIG4R_PKG = biosig_2.3.3.tar.gz
+BIOSIG4R_PKG = biosig_2.4.0.tar.gz
 
 build: $(BIOSIG4R_PKG)

=== biosig4c++/java/Makefile ===
####### Makefile for "BioSig for C/C++" #####################
###
###  Copyright (C) 2018-2020 Alois Schloegl <alois.schloegl@gmail.com>
###  This file is part of the "BioSig for C/C++" repository
###  (biosig4c++) at http://biosig.sf.net/
###
##############################################################

### JNI ###
# https://stackoverflow.com/questions/5963266/call-c-function-from-java

JAVA_HOME ?= $(realpath $(dir $(realpath $(shell which : )))/..)

CLASS_PATH ?= $(JAVA_HOME)/bin

libBiosig.so: Biosig.h Biosig.c
	$(CXX) -shared -fPIC \
		-I.. \
		-I$(JAVA_HOME)/include \
		-I$(JAVA_HOME)/include/$(shell uname -s | tr '[:upper:]' '[:lower:]') \
		Biosig.c -L.. -lbiosig -o libBiosig.so

Biosig.h: Biosig.class
	: -h . Biosig.java

Biosig.class: Biosig.java
	: Biosig.java

test: libBiosig.so
	LD_LIBRARY_PATH=.. /usr/bin/java -Djava.library.path=. Biosig "../data/Newtest17-256.bdf"

clean: 
	-rm *.h
	-rm *.o 
	-rm *.cxx 
	-rm *.so

=== biosig4c++/mex/DESCRIPTION ===
Name: mexbiosig
Version: 2.3.4
Date: 2022-03-02
Author: Alois Schloegl <alois.schloegl@ist.ac.at>
Maintainer: Alois Schlögl
Title: The mexBiosig toolbox
Description: The Biosig package provides a number of tools
   for biomedical signal processing, including importing of
   about 50 different data formations.
Depends: octave (> 3.2.0)
Recommends: general, signal, statistics, nan, tsa
SystemRequirements: octave (> 3.2.0), libbiosig1 | libbiosig2 | libbiosig3
BuildRequires: libbiosig-dev (> 1.3.0)
License: GPLv3+
Url: http://pub.ist.ac.at/~schloegl/matlab/biosig
Autoload: yes
Categories: EEG ECG EMG EOG biomedical signals dataformat

=== biosig4c++/python/Makefile ===
--- 
+++ 
@@ -13,7 +13,7 @@
 
 wheel: bdist_wheel
 
-dist/Biosig-2.3.3.tar.gz : sdist
+dist/Biosig-2.4.0.tar.gz : sdist
 
 sdist build install bdist_wheel ::
 	$(PYTHON) setup.py $@

=== debian/changelog ===
biosig (2.4.0-2build1) kinetic; urgency=medium

  * Rebuild against new libdcmtk17.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Tue, 07 Jun 2022 07:29:30 +0200

biosig (2.4.0-2) unstable; urgency=medium

  * Team upload.
  * Add arch.patch: fix baseline violation and ftbfs. (Closes: #1012416)
  * Standards-Version: 4.6.1 (routine-update)

 -- Étienne Mollier <emollier@debian.org>  Mon, 06 Jun 2022 22:21:51 +0200

biosig (2.4.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version
  * Make sure package builds with dcmtk 3.6.7
    Closes: #1010545

 -- Andreas Tille <tille@debian.org>  Thu, 12 May 2022 08:46:25 +0200

=== debian/control ===
--- 
+++ 
@@ -18,7 +18,7 @@
                libdcmtk-dev,
                libtinyxml-dev,
                libb64-dev
-Standards-Version: 4.6.0
+Standards-Version: 4.6.1
 Vcs-Browser: https://salsa.debian.org/med-team/biosig
 Vcs-Git: https://salsa.debian.org/med-team/biosig.git
 Homepage: https://biosig.sourceforge.io/
